use rhai::{FnNamespace, FuncRegistration, Module};
use std::{cell::RefCell, rc::Rc};

use crate::ui::UiState;

pub fn build_conf_module(state_src: Rc<RefCell<UiState>>) -> Module {
	let mut module = Module::new();
	module.set_id("GalacticaConfModule");

	let state = state_src.clone();
	let _ = FuncRegistration::new("show_phys")
		.with_namespace(FnNamespace::Internal)
		.set_into_module(&mut module, move |b: bool| {
			let mut ui_state = state.borrow_mut();
			ui_state.config.show_phys = b;
		});

	let state = state_src.clone();
	let _ = FuncRegistration::new("show_starfield")
		.with_namespace(FnNamespace::Internal)
		.set_into_module(&mut module, move |b: bool| {
			let mut ui_state = state.borrow_mut();
			ui_state.config.show_starfield = b;
		});

	return module;
}
